
#include "lg/interface.h"
#include "lg/scrservices.h"
#include "ScriptLib.h"
#include "GenericControl.h"


long cScrControl::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	long iRet = 1;
	if (ParamExists(m_iObjId, "on"))
	{
		const char* pszControl = ParamGetString(m_iObjId, "on");
		iRet = OnControlString(pszControl, pMsg, pReply);
	}
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrControl::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	long iRet = 1;
	if (ParamExists(m_iObjId, "off"))
	{
		const char* pszControl = ParamGetString(m_iObjId, "off");
		iRet = OnControlString(pszControl, pMsg, pReply);
	}
	if (pReply)
		MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
	return iRet;
}

long cScrControl::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pMsg->data.type != kMT_String || pMsg->data.psz == NULL)
		return 1;
	return OnControlString(pMsg->data.psz, pMsg, pReply);
}


