
#ifndef GENERICSCALE_H
#define GENERICSCALE_H

#include "GenericScript.h"


/*
 * Generic Scale
 *
 */
DECLARE_SCRIPT(cScrScale,cScrGeneric)
{
public:
	DECLARE_FACTORY(GenericScale,CustomScript);
	cScrScale(const char* pszName, int iHostObjId)
		: cScrGeneric(pszName, iHostObjId),
		  m_iScaleStim(0), m_pszScaleStimMsg(NULL)
	{ }
	virtual ~cScrScale();

private:
	DECLARE_MSGHANDLER(GenScaleBeginScript);
	DECLARE_MSGHANDLER(GenScaleEndScript);
	DECLARE_MSGHANDLER(GenScaleStimulus);

	int m_iScaleStim;
	char* m_pszScaleStimMsg;

protected:
	// arguments are the same from ReceiveMessage
	virtual long OnTurnOn(sScrMsg*,sMultiParm*);
	virtual long OnTurnOff(sScrMsg*,sMultiParm*);
	virtual long OnControl(sScrMsg*,sMultiParm*);
	// called by the default handlers
	virtual long OnScale(float,sScrMsg*,sMultiParm*) { return 1; }
	virtual void InitScriptData()
	{
		cScrGeneric::InitScriptData();
		REGISTER_MSGHANDLER("BeginScript",cScrScale::GenScaleBeginScript);
	}

};

#endif // GENERICSCALE_H
