
#include "lg/interface.h"
#include "lg/scrservices.h"
#include "ScriptLib.h"
#include "GenericTrap.h"


long cScrTrap::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	long iRet = OnSwitch(true, pMsg, pReply);
	if (iRet && pReply)
		MultiParmAssignInt(pReply, 0);
	return iRet;
}

long cScrTrap::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	long iRet = OnSwitch(false, pMsg, pReply);
	if (iRet && pReply)
		MultiParmAssignInt(pReply, 0);
	return iRet;
}

long cScrTrap::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	bool bTurnOn;
	long iRet;
	switch (pMsg->data.type)
	{
	case kMT_Int:
	case kMT_Float:
		bTurnOn = pMsg->data.i != 0;
		break;
	case kMT_String:
		if (pMsg->data.psz)
		{
			char* pszEnd;
			long iConv = strtol(pMsg->data.psz, &pszEnd, 10);
			if (pszEnd > pMsg->data.psz)
			{
				bTurnOn = iConv != 0;
				break;
			}
			else
			{
				if (!stricmp(pMsg->data.psz, "on") || 
					!stricmp(pMsg->data.psz, "turnon") ||
					!stricmp(pMsg->data.psz, "true") ||
					!stricmp(pMsg->data.psz, "yes"))
				{
					bTurnOn = true;
					break;
				}
				if (!stricmp(pMsg->data.psz, "off") || 
					!stricmp(pMsg->data.psz, "turnoff") ||
					!stricmp(pMsg->data.psz, "false") ||
					!stricmp(pMsg->data.psz, "no"))
				{
					bTurnOn = false;
					break;
				}
			}
		}
	default:
		return 1;
	}
	if (bTurnOn)
		iRet = OnTurnOn(pMsg, pReply);
	else
		iRet = OnTurnOff(pMsg, pReply);
	return iRet;
}


