
#ifndef GENERICTRIGGER_H
#define GENERICTRIGGER_H

#include "lg/types.h"


/*
 * Generic Trigger
 *
 */
class cScrTrigger
{
public:
	cScrTrigger(int iHostObjId)
		: m_iObjId(iHostObjId), m_iFlags(0)
	{ }

private:
	int m_iObjId;

protected:
	virtual long DoTurnOn(const cMultiParm& mpData);
	virtual long DoTurnOff(const cMultiParm& mpData);
	
	// Copy the Script\TrapControlFlags to m_iFlags
	virtual void InitTrigVars();
	// Test if the object is locked.
	virtual bool IsLocked(sScrMsg* pMsg);
	virtual void SetLock(bool bLock);

	// The trap control flags. The Once flag is check after your function, so you can 
	// clear it to disable that feature.
	unsigned long m_iFlags;

};

#endif // _GENERICTRIGGER_H
