#if _DARKGAME != 2
#error You gotta be kidding me.
#else

#include <cstdlib>
#include <cstring>

#include <lg/interface.h>
#include <lg/scrservices.h>
#include <lg/scrmanagers.h>
#include <lg/scrmsgs.h>
#include <lg/objects.h>
#include <lg/properties.h>
#include "ScriptLib.h"
#include "VendorLib.h"
#include "Interaction.h"


/*****************
 * KnockOnDoor
 */
MSGHANDLER cScr_KnockOnDoor::OnFrob(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<ILockSrv> pLockSrv(g_pScriptManager);
	SService<IDoorSrv> pDoorSrv(g_pScriptManager);
	if (pLockSrv->IsLocked(m_iObjId) && pDoorSrv->GetDoorState(m_iObjId) == kDoorStateClosed)
	{
		SService<IAIScrSrv> pAISrv(g_pScriptManager);
		IterateLinks("Owns", 0, m_iObjId, LinkIterFunc, this, reinterpret_cast<void*>(pAISrv.get()));
	}
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

int cScr_KnockOnDoor::LinkIterFunc(ILinkSrv* pLS, ILinkQuery* pLQ, IScript* pScript, void* pData)
{
	IAIScrSrv* pAISrv = reinterpret_cast<IAIScrSrv*>(pData);
	sLink sl;
	pLQ->Link(&sl);
	pAISrv->Signal(sl.source, "knock_knock");
	SimplePost(static_cast<cScr_KnockOnDoor*>(pScript)->m_iObjId, sl.source, "Interact", "knock_knock");
	return 1;
}


/********************
 * DisplayBook
 */
int cDisplayBookText::DisplayBookPage(const char* pszBook, int iPage)
{
	SService<IDataSrv> pDS(g_pScriptManager);
	char pszBookFile[strlen(pszBook) + 10];
	strcpy(pszBookFile, "..\\books\\");
	strcat(pszBookFile, pszBook);
	char szPage[16], szPageExtra[24];
	sprintf(szPage, "page_%d", iPage);
	cScrStr strPage, strColor, strTime, strNext, strAuto;
	pDS->GetString(strPage, pszBookFile, szPage, "", "strings");
	if (!strPage.IsEmpty())
	{
		int iColor = DefaultTextColor();
		int iTime = 0;
		sprintf(szPageExtra, "%s_color", szPage);
		pDS->GetString(strColor, pszBookFile, szPageExtra, "", "strings");
		if (!strColor.IsEmpty())
		{
			iColor = strtocolor(strColor);
		}
		strColor.Free();
		sprintf(szPageExtra, "%s_time", szPage);
		pDS->GetString(strTime, pszBookFile, szPageExtra, "", "strings");
		if (!strTime.IsEmpty())
		{
			int wait = strtotime(strTime);
			if (wait > 0)
				iTime = wait;
		}
		strTime.Free();
		if (iTime == 0)
		{
			iTime = CalcTextTime(strPage);
		}
		DisplayText(strPage, iColor, iTime);
		strPage.Free();

		sprintf(szPageExtra, "%s_auto", szPage);
		pDS->GetString(strAuto, pszBookFile, szPageExtra, "", "strings");
		if (!strAuto.IsEmpty())
		{
			int wait = strtotime(strAuto);
			if (wait > 0 || strAuto[0] == '0')
			{
				if (wait > iTime)
					iTime = wait;
			}
			else
				iTime = 0;
		}
		else
			iTime = 0;
		strAuto.Free();
		++iPage;
		sprintf(szPageExtra, "%s_next", szPage);
		pDS->GetString(strNext, pszBookFile, szPageExtra, "", "strings");
		if (!strNext.IsEmpty())
		{
			int next = strtoul(strNext, NULL, 10);
			iPage = next;
		}
		strNext.Free();
		sprintf(szPage, "page_%d", iPage);
		pDS->GetString(strPage, pszBookFile, szPage, "", "strings");
		if (strPage.IsEmpty())
			iPage = 0;
		strPage.Free();
		ChangeBookPage(pszBook, iPage, iTime);
	}
	else
	{
		strPage.Free();
		return 1;
	}

	return 0;
}

int cDisplayBookText::DisplayText(const char* pszText, int iColor, int iTime)
{
	SService<IDarkUISrv> pUI(g_pScriptManager);
	pUI->TextMessage(pszText, iColor, iTime);
	return 0;
}

int cDisplayBookText::DefaultTextColor(void)
{
	return RGB(255,255,255);
}

int cDisplayBookText::ChangeBookPage(const char* pszBook, int iPage, int iTime)
{
	return 0;
}


/********************
 * OnScreenText
 */
int cScr_OnScreenText::DisplayPage(int iPage)
{
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (!pPS->Possessed(cScrGeneric::m_iObjId, "Book"))
	{
		DebugString("Object has no book!");
		return 1;
	}
	cMultiParm mpBook;
	pPS->Get(mpBook, cScrGeneric::m_iObjId, "Book", NULL);
	if (! *static_cast<const char*>(mpBook))
	{
		DebugString("Object has no book!");
		return 1;
	}
	return DisplayBookPage(static_cast<const char*>(mpBook), iPage);
}

int cScr_OnScreenText::ChangePage(int iPage)
{
	return SetObjectParamInt(cScrGeneric::m_iObjId, "page", iPage);
}

int cScr_OnScreenText::ChangeBookPage(const char* pszBook, int iPage, int iTime)
{
	if (iTime > 0)
	{
		if (m_hAutoScroll != NULL)
			g_pScriptManager->KillTimedMessage(m_hAutoScroll);
		m_hAutoScroll = g_pScriptManager->SetTimedMessage2(cScrGeneric::m_iObjId, "AutoScroll", 
				iTime, kSTM_OneShot, cMultiParm::Undef);
	}
	return ChangePage(iPage);
}

long cScr_OnScreenText::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (m_hAutoScroll != NULL)
	{
		g_pScriptManager->KillTimedMessage(m_hAutoScroll);
		m_hAutoScroll = NULL;
	}
	int page = GetObjectParamInt(cScrGeneric::m_iObjId, "page");
	if (page < 0)
		page = 0;
	DisplayPage(page);
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

long cScr_OnScreenText::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

enum eOSTOps
{
	kOSTSet = '@',
	kOSTDisplay = '#',
	kOSTNext = '+',
	kOSTPrev = '-',
	kOSTFile = '$' // unimplemented
};

long cScr_OnScreenText::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	char op = kOSTSet;
	int iArg = -1;
	switch (pMsg->data.type)
	{
	case kMT_Int:
		iArg = pMsg->data.i;
		break;
	case kMT_Float:
		iArg = static_cast<int>(pMsg->data.f);
		break;
	case kMT_String:
		if (pMsg->data.psz)
		{
			char* pszEnd;
			int iNum = strtoul(pMsg->data.psz, &pszEnd, 10);
			if (pszEnd && *pszEnd == '\0')
				iArg = iNum;
			else
			{
				const char* pszArg = pMsg->data.psz + 1;
				op = pMsg->data.psz[0];
				if (pszArg[0] == '.')
					iArg = INT_MAX;
				else
					iArg = strtoul(pszArg, &pszEnd, 10);
			}
		}
		break;
	default:
		if (pReply)
			MultiParmAssignInt(pReply, 0);
		return 0;
	}
	if (iArg > 0)
	{
		int iPage = GetObjectParamInt(cScrGeneric::m_iObjId, "page");
		if (iArg == INT_MAX)
			iArg = iPage;
		switch (op)
		{
		case kOSTSet:
			if (iPage != iArg)
				ChangePage(iArg);
			break;
		case kOSTDisplay:
			DisplayPage(iArg);
			break;
		case kOSTNext:
		{
			int iNewPage = iPage + iArg;
			if (iPage != iNewPage)
				ChangePage(iNewPage);
			break;
		}
		case kOSTPrev:
		{
			int iNewPage = iPage - iArg;
			if (iNewPage < 0)
				iNewPage = 0;
			if (iPage != iNewPage)
				ChangePage(iNewPage);
			break;
		}
		default:
			if (pReply)
				MultiParmAssignInt(pReply, 0);
			return 0;
		}
	}
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}

MSGHANDLER cScr_OnScreenText::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sScrTimerMsg* pTimerMsg = static_cast<sScrTimerMsg*>(pMsg);
	if (stricmp(static_cast<const char*>(pTimerMsg->name),"AutoScroll"))
		return 1;

	m_hAutoScroll = NULL;
	DisplayPage(GetObjectParamInt(cScrGeneric::m_iObjId, "page"));
	return 0;
}


/*****************
 * InteractFrobHack
 */
MSGHANDLER cScr_InteractFrobHack::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	bool bIsDead = true;
	SService<IPropertySrv> pPS(g_pScriptManager);
	cMultiParm mpAIProp;
	if (pPS->Possessed(m_iObjId, "AI"))
	{
		pPS->Get(mpAIProp, m_iObjId, "AI", "Behavior set");
		if (stricmp(static_cast<const char*>(mpAIProp),"null") != 0)
		{
			cMultiParm mpMode;
			if (pPS->Possessed(m_iObjId, "AI_Mode"))
			{
				pPS->Get(mpMode, m_iObjId, "AI_Mode", NULL);
				bIsDead = static_cast<int>(mpMode) == kAIM_Dead;
			}
			else
				bIsDead = false;
		}
	}

	if (bIsDead)
		RemoveSingleMetaProperty("FrobInteract", m_iObjId);
	else
		AddSingleMetaProperty("FrobInteract", m_iObjId);

	return 1;
}

MSGHANDLER cScr_InteractFrobHack::OnAIModeChange(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sAIModeChangeMsg*>(pMsg)->mode == kAIM_Dead)
	{
		RemoveSingleMetaProperty("FrobInteract", m_iObjId);
	}
	else if (static_cast<sAIModeChangeMsg*>(pMsg)->previous_mode == kAIM_Dead)
	{
		AddSingleMetaProperty("FrobInteract", m_iObjId);
	}
	return 0;
}

MSGHANDLER cScr_InteractFrobHack::OnSlain(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	RemoveSingleMetaProperty("M-KnockedOut", m_iObjId);

	SService<IPropertySrv> pPS(g_pScriptManager);
	if (pPS->Possessed(m_iObjId, "PhysType"))
	{
		pPS->Set(m_iObjId, "PhysType", "Remove on Sleep", 1);
	}

	return 0;
}

MSGHANDLER cScr_InteractFrobHack::OnFrobWorldEnd(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	// Unlike CorpseFrobInert, we may get a frob while the AI
	// is still alive.
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (!pPS->Possessed(m_iObjId, "AI_Mode"))
	{
		return 0;
	}
	cMultiParm mpMode;
	pPS->Get(mpMode, m_iObjId, "AI_Mode", NULL);
	if (static_cast<int>(mpMode) == kAIM_Dead)
	{
		SService<IDarkGameSrv> pGS(g_pScriptManager);
		if (pGS->BindingGetFloat("auto_search") != 0)
		{
			int iContents = 0;
			{
				SService<ILinkSrv> pLS(g_pScriptManager);
				SService<ILinkToolsSrv> pLTS(g_pScriptManager);
				linkset ls;
				pLS->GetAll(ls, pLTS->LinkKindNamed("Contains"), m_iObjId, 0);
				for (; ls.AnyLinksLeft(); ls.NextLink())
				{
					if (*reinterpret_cast<int*>(ls.Data()) < 0)
					{
						// At this point, CorpseFrobHack just returns
						// but this has caused problems, so we go the extra
						// step of checking the frob info.
						sLink sl = ls.Get();
						if (pPS->Possessed(sl.dest, "FrobInfo"))
						{
							cMultiParm mpFrob;
							pPS->Get(mpFrob, sl.dest, "FrobInfo", "World Action");
							if (static_cast<int>(mpFrob) & 0x1)
							{
								iContents = sl.dest;
								break;
							}
						}
					}
				}
			}

			if (iContents != 0)
			{
				SService<IContainSrv> pCS(g_pScriptManager);
				pCS->Add(iContents, static_cast<sFrobMsg*>(pMsg)->Frobber, 0, 1);
				if (pReply)
					MultiParmAssignInt(pReply, 0);
			}
		}
	}
	return 0;
}


/*****************
 * AIInteraction
 */
MSGHANDLER cScr_AIInteraction::OnInteract(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (pMsg->data.type != kMT_String || *pMsg->data.psz == '\0')
		return 1;
	
	sLink slInteraction;
	long iInteractLink = GetAnyLinkByData("ScriptParams", m_iObjId, 0, &slInteraction, pMsg->data.psz, -1);
	if (iInteractLink == 0)
	{
		iInteractLink = GetAnyLinkByData("ScriptParams", m_iObjId, 0, &slInteraction, "Interact", -1);
		if (iInteractLink == 0)
			return 0;
		DebugPrintf("Running generic interaction (%d).", slInteraction.dest);
	}
	else
		DebugPrintf("Running \"%s\" interaction (%d).", pMsg->data.psz, slInteraction.dest);

	SimplePost(m_iObjId, slInteraction.dest, "TurnOn");

	return 0;
}

MSGHANDLER cScr_AIInteraction::OnSetInteraction(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	// unimplemented
	return 1;
}


/*****************
 * PlayerInteraction
 */
MSGHANDLER cScr_PlayerInteraction::OnToolFrob(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (!pPropSrv->Possessed(m_iObjId, "GameName"))
		return 1;
	cMultiParm mpName;
	pPropSrv->Get(mpName, m_iObjId, "GameName", NULL);
	const char* pszName = static_cast<const char*>(mpName);
	char *pszEnd;
	if (!pszName || !*pszName)
	{
		mpName = "Interact";
	}
	else if ((pszEnd = strchr(pszName, ':')))
	{
		char buf[256];
		int n = pszEnd - pszName;
		if (n > 255)
			n = 255;
		strncpy(buf, pszName, n);
		buf[n] = '\0';
		mpName = buf;
	}

	SimplePost(m_iObjId, static_cast<sFrobMsg*>(pMsg)->DstObjId, "Interact", mpName);

	return 0;
}

MSGHANDLER cScr_PlayerInteraction::OnContained(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sContainedScrMsg* pContainMsg = static_cast<sContainedScrMsg*>(pMsg);
	if (!m_bSim)
		return 0;
	if (pContainMsg->event != kContainAdd && pContainMsg->event != kContainCombine)
		return 1;

	SService<IObjectSrv> pObjSrv(g_pScriptManager);
	object oAvatar;
	pObjSrv->Named(oAvatar, "Avatar");
	true_bool __b;
	if (*(pObjSrv->InheritsFrom(__b, pContainMsg->container, oAvatar)))
	{
		object oSchema;
		pObjSrv->Named(oSchema, "new_speech");
		if (oSchema != 0)
		{
			SService<ISoundScrSrv> pSoundSrv(g_pScriptManager);
			pSoundSrv->PlaySchemaAmbient(__b, m_iObjId, oSchema, kSoundNetwork0);
		}
	}

	return 0;
}


/*****************
 * AwarenessFilter
 */
bool cScr_AwarenessFilter::TestAwareness(int from, int to, int flags)
{
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	link l;
	pLS->GetOne(l, pLTS->LinkKindNamed("AIAwareness"), from, to);
	if (l != 0)
	{
		cMultiParm mpFlags;
		pLTS->LinkGetData(mpFlags, l, "Flags");
		return (static_cast<int>(mpFlags) & flags) == flags;
	}
	return false;
}

MSGHANDLER cScr_AwarenessFilter::OnCanISeeYou(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	MultiParmAssignInt(pReply, TestAwareness(pMsg->from, m_iObjId, 0x85));
	return 0;
}

MSGHANDLER cScr_AwarenessFilter::OnCanIHearYou(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	MultiParmAssignInt(pReply, TestAwareness(pMsg->from, m_iObjId, 0x86));
	return 0;
}

MSGHANDLER cScr_AwarenessFilter::OnCanISeeObject(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = 0;
	if (pMsg->data.type == kMT_String)
	{
		obj = StrToObject(pMsg->data, pMsg->to, pMsg->from);
		if (!obj)
			return 1;
	}
	else
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		obj = static_cast<int>(pMsg->data);
		true_bool _p;
		if (! *pOS->Exists(_p, obj))
			return 1;
	}

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x85));
	return 0;
}

MSGHANDLER cScr_AwarenessFilter::OnCanIHearObject(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = 0;
	if (pMsg->data.type == kMT_String)
	{
		obj = StrToObject(pMsg->data, pMsg->to, pMsg->from);
		if (!obj)
			return 1;
	}
	else
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		obj = static_cast<int>(pMsg->data);
		true_bool _p;
		if (! *pOS->Exists(_p, obj))
			return 1;
	}

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x86));
	return 0;
}

MSGHANDLER cScr_AwarenessFilter::OnCanISeePlayer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = StrToObject("Player");
	if (!obj)
		return 1;

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x85));
	return 0;
}

MSGHANDLER cScr_AwarenessFilter::OnCanIHearPlayer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	object obj = StrToObject("Player");
	if (!obj)
		return 1;

	MultiParmAssignInt(pReply, TestAwareness(m_iObjId, obj, 0x86));
	return 0;
}


/**********************
 * TrapSignalAwareness
 */
struct sSignalAwarenessData
{
	cScrStr signal;
	int flags;
};
int cScr_SignalAwareness::AwareObjIter(ILinkSrv* pLS, ILinkQuery* pLQ, IScript* pScript, void* pData)
{
	sSignalAwarenessData* info = reinterpret_cast<sSignalAwarenessData*>(pData);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	SService<IAIScrSrv> pAISrv(g_pScriptManager);

	sLink slObj;
	pLQ->Link(&slObj);
	linkset lsLinks;
	pLS->GetAll(lsLinks, pLTS->LinkKindNamed("~AIAwareness"), slObj.dest, 0);
	for (; lsLinks.AnyLinksLeft(); lsLinks.NextLink())
	{
		sLink slAI = lsLinks.Get();
		cMultiParm mpFlags;
		pLTS->LinkGetData(mpFlags, lsLinks.Link(), "Flags");
		if ((static_cast<int>(mpFlags) & info->flags) == info->flags)
		{
			pAISrv->Signal(slAI.dest, info->signal);
		}
	}
	return 1;
}

MSGHANDLER cScr_SignalAwareness::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		FixupPlayerLinks();
	}
	return 1;
}

long cScr_SignalAwareness::OnSwitch(bool bTurnOn, sScrMsg* pMsg, sMultiParm* pReply)
{
	if (bTurnOn)
	{
		const char* pszSignal = ParamGetString(m_iObjId, "signal");
		if (!pszSignal)
			return 1;

		sSignalAwarenessData info;
		info.signal = pszSignal;
		info.flags = 0x84 | ParamGetInt(m_iObjId, "awareness");
		/*
		switch(GetParamInt(m_iObjId, "awareness"))
		{
		case 3: // actually, I think this will never happen
			info.flags = 0x87;
			break;
		case 2:
			info.flags = 0x86;
			break;
		case 1:
			info.flags = 0x85;
			break;
		default:
			info.flags = 0x84;
			break;
		}
		*/

		IterateLinks("ControlDevice", m_iObjId, 0, AwareObjIter, this, reinterpret_cast<void*>(&info));
	}

	return 0;
}


/**************
 * PrivateRoom
 */
void cScr_PrivateRoom::TestAwareness(int iMoveObjId)
{
	DebugString("Testing awareness");
	SService<IAIScrSrv> pAISrv(g_pScriptManager);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	linkset lsLinks;
	pLS->GetAll(lsLinks, pLTS->LinkKindNamed("~AIAwareness"), iMoveObjId, 0);
	for (; lsLinks.AnyLinksLeft(); lsLinks.NextLink())
	{
		cMultiParm mpFlags;
		pLTS->LinkGetData(mpFlags, lsLinks.Link(), "Flags");
		if ((static_cast<int>(mpFlags) & 0x89) == 0x89)
		{
			sLink sl = lsLinks.Get();
			char sz[12];
			sprintf(sz,"%d",sl.dest);
			DebugString("Signalling AI", sz);
			pAISrv->Signal(sl.dest, "alarm");
		}
	}
}

MSGHANDLER cScr_PrivateRoom::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "PrivateRoom")
	 && 0 != static_cast<int>(pMsg->data))
	{
		if (! m_bPlayerBreach)
		{
			DebugString("Removing links");
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->DestroyMany(pLTS->LinkKindNamed("AIWatchObj"), 
					"@Human", static_cast<const char*>(pMsg->data));
		}
		TestAwareness(static_cast<int>(pMsg->data));
		return 0;
	}
	return 1;
}

MSGHANDLER cScr_PrivateRoom::OnRoomEnter(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sRoomMsg* pRoomMsg = static_cast<sRoomMsg*>(pMsg);
	m_bPlayerBreach = 0;
	DebugString("PlayerEnter");
	SService<IObjectSrv> pOS(g_pScriptManager);
	object oMP;
	pOS->Named(oMP, "M-PlayerBreach");
	if (oMP == 0)
	{
		DebugString("Damn, no meta-prop");
		return 1;
	}
	true_bool _p;
	if (! *pOS->HasMetaProperty(_p, pRoomMsg->MoveObjId, oMP))
	{
		DebugString("Adding meta-prop");
		pOS->AddMetaProperty(pRoomMsg->MoveObjId, oMP);
	}

	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	char szPlayerDesc[12];
	sprintf(szPlayerDesc, "%d", pRoomMsg->MoveObjId);
	DebugString("Creating AIWatchObj links");
	linkkind lk = pLTS->LinkKindNamed("AIWatchObj");
	pLS->DestroyMany(lk, "@Human", szPlayerDesc);
	pLS->CreateMany(lk, "@Human", szPlayerDesc);
	
	TestAwareness(pRoomMsg->MoveObjId);

	return 0;
}

MSGHANDLER cScr_PrivateRoom::OnRoomExit(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	m_bPlayerBreach = 0;
	DebugString("PlayerExit");
	SService<IObjectSrv> pOS(g_pScriptManager);
	object oMP;
	pOS->Named(oMP, "M-PlayerBreach");
	if (oMP != 0)
	{
		pOS->RemoveMetaProperty(static_cast<sRoomMsg*>(pMsg)->MoveObjId, oMP);
	}
	int iTime = ParamGetTime(m_iObjId, "exit_time", 1000);
	g_pScriptManager->SetTimedMessage2(m_iObjId, "PrivateRoom", iTime, kSTM_OneShot, 
			static_cast<sRoomMsg*>(pMsg)->MoveObjId);
	return 0;
}


/**********************
 * VendorRelay
 */
MSGHANDLER cScr_VendorRelay::OnRelay(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	InitTrigVars();
	if (IsLocked(pMsg))
		return 0;

	eVendorDebitType eType = kDebitGold;
	const char* pszLoot = ParamGetString(cScript::m_iObjId, "loot");
	if (!pszLoot)
	{
		DebugString("No loot param. Cowardly doing nothing.");
		return 1;
	}
	const char* pszVendor = ParamGetString(cScript::m_iObjId, "vendor");
	if (pszVendor)
	{
		if (!stricmp(pszVendor, "exact"))
			eType = kDebitExact;
		else if (!stricmp(pszVendor, "even"))
			eType = kDebitEvenly;
		else if (!stricmp(pszVendor, "gold_first"))
			eType = kDebitGoldFirst;
		else if (!stricmp(pszVendor, "goods_only"))
			eType = kDebitGoods;
		else if (!stricmp(pszVendor, "gems_only"))
			eType = kDebitGems;
		else if (!stricmp(pszVendor, "gold_only"))
			eType = kDebitGold;
		else
			DebugString("unsupported vendor type (assuming gold_only): ", pszVendor);
	}
	char* pszComma = strchr(pszLoot, ',');
	if (pszComma)
	{
		int iGold, iGems, iGoods;
		iGold = strtol(pszLoot, NULL, 10);
		iGems = strtol(++pszComma, NULL, 10);
		pszComma = strchr(pszComma, ',');
		iGoods = strtol(pszComma, NULL, 10);
		if (VendorDebitLoot(0, iGold, iGems, iGoods))
		{
			DoTurnOn(0);
		}
		else
		{
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->BroadcastOnAllLinksData(cScript::m_iObjId, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
		}
	}
	else
	{
		int iAmount = strtol(pszLoot, NULL, 10);
		if (iAmount == 0 || VendorDebitLoot(0, iAmount, eType))
		{
			DoTurnOn(0);
		}
		else
		{
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->BroadcastOnAllLinksData(cScript::m_iObjId, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
		}
	}
	if (pReply)
		MultiParmAssignInt(pReply, 1);
	return 0;
}


/**********************
 * LootExchange
 */
MSGHANDLER cScr_LootExchange::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		SService<IPropertySrv> pPS(g_pScriptManager);
		if (pPS->Possessed(m_iObjId, "TrapQVar"))
		{
			cMultiParm mpQVar;
			pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
			SService<IQuestSrv> pQS(g_pScriptManager);
			if (!pQS->Exists(static_cast<const char*>(mpQVar)))
				pQS->Set(static_cast<const char*>(mpQVar), 0, 0);
		}
	}
	return 1;
}

long cScr_LootExchange::OnSwitch(bool bTurnOn, sScrMsg* pMsg, sMultiParm* pReply)
{
	if (bTurnOn)
	{
		int iPlayer = StrToObject("Player");
		if (!iPlayer)
			return 1;
		
		SService<IPropertySrv> pPS(g_pScriptManager);
		SService<IQuestSrv> pQS(g_pScriptManager);
		int iAmount = 0;
		cAnsiStr strQVar;
		if (pPS->Possessed(m_iObjId, "TrapQVar"))
		{
			cMultiParm mpQVar;
			pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
			strQVar = static_cast<const char*>(mpQVar);
			iAmount = pQS->Get(strQVar) % 10000;
		}
		if (iAmount == 0)
			return 0;
		eVendorDebitType eType = kDebitEvenly;
		const char* pszVendor = ParamGetString(m_iObjId, "vendor");
		if (pszVendor)
		{
			if (!stricmp(pszVendor, "even"))
				eType = kDebitEvenly;
			else if (!stricmp(pszVendor, "goods_only"))
				eType = kDebitGoods;
			else if (!stricmp(pszVendor, "gems_only"))
				eType = kDebitGems;
			else
				DebugString("unsupported vendor type (assuming even): ", pszVendor);
		}
		float fExchangeRate;
		if (ParamExists(m_iObjId, "exchange"))
		{
			fExchangeRate = ParamGetFloat(m_iObjId, "exchange");
		}
		else
		{
			int ex_p, ex_q;
			ex_q = ParamGetInt(m_iObjId, "exchange_q", 0);
			if (ex_q != 0)
			{
				ex_p = ParamGetInt(m_iObjId, "exchange_p", 0);
				fExchangeRate = (float)ex_p/(float)ex_q;
			}
			else
				fExchangeRate = 1.0;
		}
		if (fExchangeRate == 0.0)
			return 0;
		int iAdd = int((float)iAmount * fExchangeRate);
		if (iAdd < 1)
			iAdd = 1;
		int iGold = 0, iGems = 0, iGoods = 0;
		VendorGetLoot(iPlayer, &iGold, &iGems, &iGoods);
		iGold = 0;
		switch (eType)
		{
		case kDebitGems:
			if (iGems >= iAmount)
			{
				iGold = iAdd;
				iGems = -iAmount;
				iGoods = 0;
			}
			else
				iGold = -1;
			break;
		case kDebitGoods:
			if (iGoods >= iAmount)
			{
				iGold = iAdd;
				iGoods = -iAmount;
				iGems = 0;
			}
			else
				iGold = -1;
			break;
		case kDebitEvenly:
			if (iGems + iGoods >= iAmount)
			{
				iGold = iAdd;
				div_t d = div(iAmount, 2);
				int iDebit[2];
				iDebit[1] = iDebit[0] = d.quot;
				if (iGoods < d.quot)
				{
					d.rem += d.quot - iGoods;
					iDebit[1] = iGoods;
					iGoods = 0;
				}
				else
					iGoods -= d.quot;
				if (iGems < d.quot)
				{
					d.rem += d.quot - iGems;
					iDebit[0] = iGems;
					iGems = 0;
				}
				else
					iGems -= d.quot;
				while (d.rem--)
				{
					if (iGems < iGoods)
					{
						--iGoods;
						++iDebit[1];
					}
					else
					{
						--iGems;
						++iDebit[0];
					}
				}
				iGems = -iDebit[0];
				iGoods = -iDebit[1];
			}
			else
				iGold = -1;
		default:
			break;
		}
		if (iGold >= 0)
		{
			VendorAddLoot(iPlayer, iGold, iGems, iGoods);
			pQS->Set(strQVar, 0, 0);
			CDSend("TurnOn", m_iObjId);
		}
		else
		{
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->BroadcastOnAllLinksData(m_iObjId, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
		}
	}
	return 0;
}


/**********************
 * PurchaseItem
 */
MSGHANDLER cScr_PurchaseItem::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		FixupPlayerLinks();

		int iQVObj = 0;
		int iStore = VendorGetStore(m_iObjId);
		SService<IPropertySrv> pPS(g_pScriptManager);
		if (pPS->Possessed(iStore, "TrapQVar"))
			iQVObj = iStore;
		else if (pPS->Possessed(m_iObjId, "TrapQVar"))
			iQVObj = m_iObjId;
		if (iQVObj)
		{
			cMultiParm mpQVar;
			pPS->Get(mpQVar, iQVObj, "TrapQVar", NULL);
			SService<IQuestSrv> pQS(g_pScriptManager);
			if (!pQS->Exists(static_cast<const char*>(mpQVar)))
				pQS->Set(static_cast<const char*>(mpQVar), 0, 0);
		}
	}
	return 1;
}

MSGHANDLER cScr_PurchaseItem::OnReset(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	int iStore = VendorGetStore(m_iObjId);
	int iCart = VendorGetCart(m_iObjId);
	int iItem = VendorGetItem(m_iObjId);
	if (!iStore || !iItem)
		return 1;
	if (!iCart)
		iCart = iStore;
	SService<IPropertySrv> pPS(g_pScriptManager);
	SService<IObjectSrv> pOS(g_pScriptManager);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	int iArchetype;
	if (iItem > 0)
	{
		SInterface<ITraitManager> pTM(g_pScriptManager);
		iArchetype = pTM->GetArchetype(iItem);
	}
	else
		iArchetype = iItem;
	cMultiParm mpProp;
	linkset lsCont;
	pLS->GetAll(lsCont, pLTS->LinkKindNamed("Contains"), iCart, 0);
	for (; lsCont.AnyLinksLeft(); lsCont.NextLink())
	{
		sLink slCont = lsCont.Get();
		true_bool __arc;
		if (*pLS->AnyExist(__arc, pLTS->LinkKindNamed("MetaProp"), slCont.dest, iArchetype))
		{
			if (iItem > 0 && pPS->Possessed(iItem, "StackCount"))
			{
				int iStack = 1;
				if (pPS->Possessed(slCont.dest, "StackCount"))
				{
					pPS->Get(mpProp, slCont.dest, "StackCount", NULL);
					iStack = static_cast<int>(mpProp);
				}
				pPS->Get(mpProp, iItem, "StackCount", NULL);
				pPS->SetSimple(iItem, "StackCount", iStack + static_cast<int>(mpProp));
			}
			// It isn't necessary to change the QVar, as it is almost 
			// certain that whatever caused the Reset message will also
			// reset the QVar to zero.
			pOS->Destroy(slCont.dest);
			break;
		}
	}
	return 0;
}

long cScr_PurchaseItem::OnControl(sScrMsg* pMsg, sMultiParm* pReply)
{
	if (pMsg->data.type == kMT_String
	 && !stricmp(pMsg->data.psz, "reset"))
	{
		long iRet = OnReset(pMsg, pReply, kNoAction);
		if (pReply)
			MultiParmAssignInt(pReply, (iRet) ? 0 : 1);
		return iRet;
	}
	return cScrTrap::OnControl(pMsg, pReply);
}

long cScr_PurchaseItem::OnSwitch(bool bTurnOn, sScrMsg* pMsg, sMultiParm* pReply)
{
	int iStore = VendorGetStore(m_iObjId);
	int iCart = VendorGetCart(m_iObjId);
	int iItem = VendorGetItem(m_iObjId);
	if (!iStore || !iItem)
		return 1;
	if (!iCart)
		iCart = iStore;

	SService<IPropertySrv> pPS(g_pScriptManager);
	SService<IObjectSrv> pOS(g_pScriptManager);
	if (bTurnOn)
	{
		int iItemCount = 1;
		cMultiParm mpProp;
		if (pPS->Possessed(iItem, "StackCount"))
		{
			pPS->Get(mpProp, iItem, "StackCount", 0);
			iItemCount = static_cast<int>(mpProp);
		}
		if (iItemCount == 0)
		{
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->BroadcastOnAllLinksData(m_iObjId, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
			return 1;
		}
		object oNewItem;
		pOS->Create(oNewItem, iItem);
		if (!oNewItem)
			return 1;
		if (iItem > 0 || !pPS->Possessed(iItem, "StackCount"))
		{
			if (!pPS->Possessed(oNewItem, "StackCount"))
				pPS->Add(oNewItem, "StackCount");
			pPS->SetSimple(oNewItem, "StackCount", 1);
		}
		int iQVObj = 0;
		if (pPS->Possessed(iStore, "TrapQVar"))
			iQVObj = iStore;
		else if (pPS->Possessed(m_iObjId, "TrapQVar"))
			iQVObj = m_iObjId;
		if (iQVObj)
		{
			SService<IQuestSrv> pQS(g_pScriptManager);
			cMultiParm mpTallyVar;
			pPS->Get(mpTallyVar, iQVObj, "TrapQVar", NULL);
			int iPrice = 0;
			if (pPS->Possessed(iItem, "SalePrice"))
			{
				pPS->Get(mpProp, iItem, "SalePrice", NULL);
				iPrice = static_cast<int>(mpProp);
			}
			int iTally = (pQS->Get(static_cast<const char*>(mpTallyVar)) % 10000) + iPrice;
			if (iTally > 9999)
			{
				SService<ILinkSrv> pLS(g_pScriptManager);
				SService<ILinkToolsSrv> pLTS(g_pScriptManager);
				pLS->BroadcastOnAllLinksData(iQVObj, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
				pOS->Destroy(oNewItem);
				return 1;
			}
			pQS->Set(static_cast<const char*>(mpTallyVar), iTally, 0);
		}
		if (iItem > 0)
		{
			if (!pPS->Possessed(iItem, "StackCount"))
				pPS->Add(iItem, "StackCount");
			pPS->SetSimple(iItem, "StackCount", iItemCount-1);
		}
		SService<IContainSrv> pCont(g_pScriptManager);
		pCont->Add(oNewItem, iCart, 0, 1);
	}
	else
	{
		SService<ILinkSrv> pLS(g_pScriptManager);
		SService<ILinkToolsSrv> pLTS(g_pScriptManager);
		int iArchetype;
		if (iItem > 0)
		{
			SInterface<ITraitManager> pTM(g_pScriptManager);
			iArchetype = pTM->GetArchetype(iItem);
		}
		else
			iArchetype = iItem;
		cMultiParm mpProp;
		linkset lsCont;
		pLS->GetAll(lsCont, pLTS->LinkKindNamed("Contains"), iCart, 0);
		for (; lsCont.AnyLinksLeft(); lsCont.NextLink())
		{
			sLink slCont = lsCont.Get();
			true_bool __arc;
			if (*pLS->AnyExist(__arc, pLTS->LinkKindNamed("MetaProp"), slCont.dest, iArchetype))
			{
				int iIncrement = 1;
				int iStack = 1;
				if (iItem < 0 && pPS->Possessed(iItem, "StackCount"))
				{
					pPS->Get(mpProp, iItem, "StackCount", NULL);
					iIncrement = static_cast<int>(mpProp);
				}
				if (pPS->Possessed(slCont.dest, "StackCount"))
				{
					pPS->Get(mpProp, slCont.dest, "StackCount", NULL);
					iStack = static_cast<int>(mpProp);
				}
				iStack -= iIncrement;
				if (iStack > 0)
					pPS->SetSimple(slCont.dest, "StackCount", iStack);
				else
					pOS->Destroy(slCont.dest);
				int iQVObj = 0;
				if (pPS->Possessed(iStore, "TrapQVar"))
					iQVObj = iStore;
				else if (pPS->Possessed(m_iObjId, "TrapQVar"))
					iQVObj = m_iObjId;
				if (iQVObj)
				{
					SService<IQuestSrv> pQS(g_pScriptManager);
					cMultiParm mpTallyVar;
					pPS->Get(mpTallyVar, iQVObj, "TrapQVar", NULL);
					int iPrice = 0;
					if (pPS->Possessed(iItem, "SalePrice"))
					{
						pPS->Get(mpProp, iItem, "SalePrice", NULL);
						iPrice = static_cast<int>(mpProp);
					}
					int iTally = (pQS->Get(static_cast<const char*>(mpTallyVar)) % 10000) - iPrice;
					if (iTally < 0)
						iTally = 0;
					pQS->Set(static_cast<const char*>(mpTallyVar), iTally, 0);
				}
				if (iItem > 0)
				{
					if (pPS->Possessed(iItem, "StackCount"))
					{
						pPS->Get(mpProp, iItem, "StackCount", NULL);
						pPS->SetSimple(iItem, "StackCount", iIncrement + static_cast<int>(mpProp));
					}
				}
				break;
			}
		}
	}
	return 0;
}


/**********************
 * ShoppingCart
 */
MSGHANDLER cScr_ShoppingCart::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	m_iReallyLocked.Init(0);

	SService<IPropertySrv> pPS(g_pScriptManager);
	if (pPS->Possessed(m_iObjId, "TrapQVar"))
	{
		cMultiParm mpQVar;
		pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
		SService<IQuestSrv> pQS(g_pScriptManager);
		pQS->SubscribeMsg(m_iObjId, static_cast<const char*>(mpQVar), 2);
	}
	return 1;
}

MSGHANDLER cScr_ShoppingCart::OnEndScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (pPS->Possessed(m_iObjId, "TrapQVar"))
	{
		cMultiParm mpQVar;
		pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
		SService<IQuestSrv> pQS(g_pScriptManager);
		pQS->UnsubscribeMsg(m_iObjId, static_cast<const char*>(mpQVar));
	}
	return 1;
}

MSGHANDLER cScr_ShoppingCart::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		FixupPlayerLinks();

		SService<IPropertySrv> pPS(g_pScriptManager);
		if (!pPS->Possessed(m_iObjId, "Locked"))
		{
			pPS->Add(m_iObjId, "Locked");
		}
		if (pPS->Possessed(m_iObjId, "TrapQVar"))
		{
			cMultiParm mpQVar;
			int iQVal = 0;
			pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
			SService<IQuestSrv> pQS(g_pScriptManager);
			if (pQS->Exists(static_cast<const char*>(mpQVar)))
				iQVal = pQS->Get(static_cast<const char*>(mpQVar));
			else
				pQS->Set(static_cast<const char*>(mpQVar), 0, 0);
			pPS->SetSimple(m_iObjId, "Locked", int(iQVal != 0));
		}
	}
	return 1;
}

MSGHANDLER cScr_ShoppingCart::OnQuestChange(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sQuestMsg* pQuest = static_cast<sQuestMsg*>(pMsg);
	SService<IPropertySrv> pPS(g_pScriptManager);
	if (pQuest->m_oldValue == 0 && pQuest->m_newValue > 0)
	{
		pPS->SetSimple(m_iObjId, "Locked", 1);
	}
	else if (pQuest->m_newValue == 0 && pQuest->m_oldValue > 0)
	{
		pPS->SetSimple(m_iObjId, "Locked", 0);
	}
	return 0;
}

long cScr_ShoppingCart::OnSwitch(bool bTurnOn, sScrMsg* pMsg, sMultiParm* pReply)
{
	int iCart = VendorGetCart(m_iObjId);
	if (!iCart)
		iCart = m_iObjId;

	SService<IPropertySrv> pPS(g_pScriptManager);
	SService<IQuestSrv> pQS(g_pScriptManager);

	if (bTurnOn)
	{
		int iTally = 0;
		cAnsiStr strQVar;
		if (pPS->Possessed(m_iObjId, "TrapQVar"))
		{
			cMultiParm mpQVar;
			pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
			strQVar = static_cast<const char*>(mpQVar);
			if (!strQVar.IsEmpty())
				iTally = pQS->Get(strQVar) % 10000;
		}

		eVendorDebitType eType = kDebitGold;
		const char* pszVendor = ParamGetString(m_iObjId, "vendor");
		if (pszVendor)
		{
			if (!stricmp(pszVendor, "even"))
				eType = kDebitEvenly;
			else if (!stricmp(pszVendor, "gold_first"))
				eType = kDebitGoldFirst;
			else if (!stricmp(pszVendor, "goods_only"))
				eType = kDebitGoods;
			else if (!stricmp(pszVendor, "gems_only"))
				eType = kDebitGems;
			else if (!stricmp(pszVendor, "gold_only"))
				eType = kDebitGold;
			else
				DebugString("unsupported vendor type (assuming gold_only): ", pszVendor);
		}
		if (iTally == 0 || VendorDebitLoot(0, iTally, eType))
		{
			if (!strQVar.IsEmpty())
				pQS->Set(strQVar, 0, 0);
			int iPlayer = StrToObject("Player");
			if (iPlayer && iCart == m_iObjId)
			{
				SService<IContainSrv> pCS(g_pScriptManager);
				pCS->MoveAllContents(iCart, iPlayer, 1);
			}
		}
		else
		{
			SService<ILinkSrv> pLS(g_pScriptManager);
			SService<ILinkToolsSrv> pLTS(g_pScriptManager);
			pLS->BroadcastOnAllLinksData(m_iObjId, "TurnOn", pLTS->LinkKindNamed("ScriptParams"), "ErrorOutput");
		}
	}
	else
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		SService<ILinkSrv> pLS(g_pScriptManager);
		SService<ILinkToolsSrv> pLTS(g_pScriptManager);
		// If you use concrete store items, you better use "Store" links
		{
			linkset ls;
			pLS->GetAll(ls, pLTS->LinkKindNamed("~ScriptParams"), m_iObjId, 0);
			for (; ls.AnyLinksLeft(); ls.NextLink())
			{
				if (stricmp(reinterpret_cast<const char*>(ls.Data()), "Store"))
					continue;
				sLink sl = ls.Get();
				SimpleSend(m_iObjId, sl.dest, "Reset");
			}
		}
		linkset ls;
		pLS->GetAll(ls, pLTS->LinkKindNamed("Contains"), iCart, 0);
		for (; ls.AnyLinksLeft(); ls.NextLink())
		{
			sLink sl = ls.Get();
			pOS->Destroy(sl.dest);
		}
		if (pPS->Possessed(m_iObjId, "TrapQVar"))
		{
			cMultiParm mpQVar;
			pPS->Get(mpQVar, m_iObjId, "TrapQVar", NULL);
			pQS->Set(static_cast<const char*>(mpQVar), 0, 0);
		}
	}
	return 0;
}


/**********************
 * LootStats
 */
MSGHANDLER cScr_LootTracker::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	m_bTracking.Init(0);
	m_iCurrentLoot.Init(0);
	/* This is a bit tricky, because of the unusual message sequence
	 * the Player object has to deal with. Plus the game acts differently 
	 * when playing through DromEd compared to the mission loop...
	 *
	 * This is what works. That's all you need to know.
	 */
	if (m_iObjId == StrToObject("Player"))
		g_pScriptManager->SetTimedMessage2(m_iObjId, "LootTracking", 450, kSTM_OneShot, 1);
	return 1;
}

MSGHANDLER cScr_LootTracker::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		SService<IQuestSrv> pQS(g_pScriptManager);
		int iLoot = pQS->Get("total_loot");
		if (iLoot > 0 && 0 != pQS->Get("loot_carryover"))
		{
			char szGoalState[24];
			char szGoalType[24];
			int iGoalNum;
			for (iGoalNum = 0; true; ++iGoalNum)
			{
				sprintf(szGoalState, "goal_state_%d", iGoalNum);
				if (!pQS->Exists(szGoalState))
					break;
				sprintf(szGoalType, "goal_type_%d", iGoalNum);
				if (kGoalLoot == pQS->Get(szGoalType))
				{
					sprintf(szGoalType, "goal_loot_%d", iGoalNum);
					if (pQS->Exists(szGoalType))
					{
						pQS->Set(szGoalType, iLoot + pQS->Get(szGoalType), 0);
					}
					sprintf(szGoalType, "goal_gold_%d", iGoalNum);
					if (pQS->Exists(szGoalType))
					{
						pQS->Set(szGoalType, iLoot + pQS->Get(szGoalType), 0);
					}
				}
			}

			VendorAddLoot(m_iObjId, iLoot);
			pQS->Set("loot_carryover", 1, 0);
		}
	}
	else
	{
		if (m_bTracking != 0)
		{
			m_bTracking = 0;
			
			SService<IQuestSrv> pQS(g_pScriptManager);
			int iFound = pQS->Get("DrSLootFound");
			if (pQS->Exists("DrSCmLootFound"))
			{
				iFound += pQS->Get("DrSCmLootFound");
				pQS->Delete("DrSCmLootFound");
			}
			pQS->Set("DrSCmLootFound", iFound, 1);
			pQS->Delete("DrSLootFound");
			int iSpent = pQS->Get("DrSLootSpent");
			if (pQS->Exists("DrSCmLootSpent"))
			{
				iFound += pQS->Get("DrSCmLootSpent");
				pQS->Delete("DrSCmLootSpent");
			}
			pQS->Set("DrSCmLootSpent", iSpent, 1);
			pQS->Delete("DrSLootSpent");
		}
	}
	return 1;
}

MSGHANDLER cScr_LootTracker::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "LootTracking"))
	{
		m_iCurrentLoot = VendorGetLoot(m_iObjId, NULL, NULL, NULL);
		m_bTracking = 1;
		SService<IQuestSrv> pQS(g_pScriptManager);
		//if (pQS->Exists("DrSLootFound"))
		//	pQS->Delete("DrSLootFound");
		pQS->Set("DrSLootFound",0,0);
		//if (pQS->Exists("DrSLootSpent"))
		//	pQS->Delete("DrSLootSpent");
		pQS->Set("DrSLootSpent",0,0);
		return 0;
	}
	return 1;
}

MSGHANDLER cScr_LootTracker::OnContainer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (m_iObjId != StrToObject("Player"))
		return 1;
	if (m_bTracking)
	{
		sContainerScrMsg* pContMsg = static_cast<sContainerScrMsg*>(pMsg);
		int iLoot = VendorGetLoot(pContMsg->containee, NULL, NULL, NULL);
		if (iLoot)
		{
			SService<IQuestSrv> pQS(g_pScriptManager);
			if (pContMsg->event == kContainRemove)
				iLoot = -iLoot;
			else if (pContMsg->event == kContainCombine)
				iLoot -= m_iCurrentLoot;
			if (iLoot > 0)
				pQS->Set("DrSLootFound", iLoot + pQS->Get("DrSLootFound"), 0);
			else
				pQS->Set("DrSLootSpent", (-iLoot) + pQS->Get("DrSLootSpent"), 0);
			m_iCurrentLoot += iLoot;
		}
		return 0;
	}
	return 1;
}


/**********************
 * AIFactory
 */
MSGHANDLER cScr_Spawn::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		object oNewAI, oAIType;
		sLink slFactory;
		if (GetAnyLinkByData("ScriptParams", m_iObjId, 0, &slFactory, "Spawn", -1))
		{
			DeleteAllLinksByData("ScriptParams", m_iObjId, 0, "Spawn", -1);
			oAIType = slFactory.dest;

			cScrStr strName;
			pOS->GetName(strName, oAIType);
			DebugPrintf("AIFactory: Spawning a %s\n", static_cast<const char*>(strName));
			strName.Free();
		}
		if (oAIType)
		{
			pOS->BeginCreate(oNewAI, oAIType);
			if (oNewAI)
			{
				// Copy metaproperties
				SInterface<ITraitManager> pTM(g_pScriptManager);
				IObjectQuery* pOQ = pTM->Query(m_iObjId, kTraitQueryMetaProps);
				if (pOQ)
				{
					for (; ! pOQ->Done(); pOQ->Next())
					{
						if (pTM->IsMetaProperty(pOQ->Object()))
						{
							pTM->AddObjMetaProperty(oNewAI, pOQ->Object());
						}
					}
					pOQ->Release();
				}

				// Copy properties
				SInterface<IPropertyManager> pPM(g_pScriptManager);
				IProperty* pProp;
				// These two are ignored.
				// If you need scripts for the AI, use a metaprop
				int iScriptProp = 0;
				int iBrushProp = 0;
				pProp = pPM->GetPropertyNamed("Scripts");
				if (pProp)
				{
					iScriptProp = pProp->GetID();
					pProp->Release();
				}
				pProp = pPM->GetPropertyNamed("Brush");
				if (pProp)
				{
					iBrushProp = pProp->GetID();
					pProp->Release();
				}
				sPropertyIter props;
				pPM->BeginIter(&props);
				while ((pProp = pPM->NextIter(&props)))
				{
					if (pProp->IsSimplyRelevant(m_iObjId))
					{
						if (pProp->GetID() != iScriptProp 
						 && pProp->GetID() != iBrushProp)
						{
							pProp->Copy(oNewAI, m_iObjId);
						}
					}
					pProp->Release();
				}

				// Copy links
				SInterface<ILinkManager> pLM(g_pScriptManager);
				short iMPRel = 0;
				IRelation* pMPRel = pLM->GetRelationNamed("MetaProp");
				if (pMPRel)
				{
					iMPRel = pMPRel->GetID();
					pMPRel->Release();
				}
				ILinkQuery* pLQ = pLM->Query(m_iObjId, 0, 0);
				if (pLQ)
				{
					for (; ! pLQ->Done(); pLQ->Next())
					{
						sLink sl;
						pLQ->Link(&sl);
						if (sl.flavor != iMPRel)
						{
							// AIWatchLinkDefaults messes this up.
							// Copy the data in two steps.
							long lNew = pLM->Add(oNewAI, sl.dest, sl.flavor);
							void* pData = pLM->GetData(pLQ->ID());
							if (pData)
								pLM->SetData(lNew, pData);
						}
					}
					pLQ->Release();
				}

				pOS->EndCreate(oNewAI);

				/* Copying the Position prop handles this
				pOS->Teleport(oNewAI, cScrVec::Zero, cScrVec::Zero, m_iObjId);
				*/
			}
		}
		pOS->Destroy(m_iObjId);
	}
	return 1;
}


#endif // DARKGAME == 2
