/*****************************************************
 * tnhScript.cc was getting crowded
 * I'll put the hack/patch scripts here.
 */
#if _DARKGAME != 2
#error You gotta be kidding me.
#else


#include <cstdlib>
#include <cstring>
#include <cctype>

#include "lg/interface.h"
#include "lg/scrservices.h"
#include "lg/scrmanagers.h"
#include "lg/scrmsgs.h"
#include "lg/properties.h"
#include "lg/propdefs.h"
#include "lg/gen.h"
#include "ScriptLib.h"
#include "NewScript.h"


/*****************
 * NewCrystal
 */
MSGHANDLER cScr_NewCrystal::OnContained(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sContainedScrMsg* pContainMsg = static_cast<sContainedScrMsg*>(pMsg);
	if (pContainMsg->event != kContainAdd && pContainMsg->event != kContainCombine)
		return 1;

	SService<IObjectSrv> pObjSrv(g_pScriptManager);
	object oAvatar;
	pObjSrv->Named(oAvatar, "Avatar");
	true_bool bIsAvatar;
	if (*(pObjSrv->InheritsFrom(bIsAvatar, pContainMsg->container, oAvatar)))
	{
		return TransmogrifyCrystal(pObjSrv, pContainMsg->container);
	}
	return 1;
}

long cScr_NewCrystal::TransmogrifyCrystal(IObjectSrv* pObjSrv, int iDest)
{
	sLink slArrow;
	if (!GetAnyLinkByDataInheritedSrc("ScriptParams", m_iObjId, 0, &slArrow, "Crystal", -1))
		return 1;
	object oArrow;
	pObjSrv->Create(oArrow, slArrow.dest);
	if (oArrow == 0)
		return 1;
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (pPropSrv->Possessed(m_iObjId, "StackCount"))
	{
		cMultiParm mpStack;
		pPropSrv->Get(mpStack, m_iObjId, "StackCount", NULL);
		pPropSrv->SetSimple(oArrow, "StackCount", mpStack);
	}
	SService<IContainSrv> pContainSrv(g_pScriptManager);
	pContainSrv->Add(oArrow, iDest, 0, 1);
	pObjSrv->Destroy(m_iObjId);
	return 0;
}


/******************
 * NewKey
 */
cScr_NewKey::~cScr_NewKey()
{
	if (m_pStdKey)
		m_pStdKey->Release();
}

void cScr_NewKey::InitScriptData()
{
	const sScrClassDesc* scr = g_pScriptManager->GetClass("StdKey");
	if (scr)
		m_pStdKey = (*scr->pfnFactory)(scr->pszClass, m_iObjId);

	cScript::InitScriptData();
	RegisterMessageHandler("FrobToolEnd", static_cast<MessageHandlerFunc>(&cScr_NewKey::OnFrobToolEnd));
}

long __stdcall cScr_NewKey::ReceiveMessage(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	long iRet = cScript::ReceiveMessage(pMsg, pReply, eTrace);
	if (m_pStdKey && iRet) {
		iRet = m_pStdKey->ReceiveMessage(pMsg, pReply, eTrace);
	}
	return iRet;
}

MSGHANDLER cScr_NewKey::OnFrobToolEnd(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	sFrobMsg* pFrobMsg = static_cast<sFrobMsg*>(pMsg);
	SService<IKeySrv> pKeySrv(g_pScriptManager);
	int iSuccess = pKeySrv->TryToUseKey(m_iObjId, pFrobMsg->DstObjId, kKeyUseCheck);
	SService<IObjectSrv> pObjSrv(g_pScriptManager);
	object oPlayer;
	pObjSrv->Named(oPlayer, "Player");
	if (iSuccess)
	{
		if (pFrobMsg->Frobber == oPlayer)
		{
			SimpleSend(m_iObjId, pFrobMsg->DstObjId, "PlayerToolFrob");
			SService<ILockSrv> pLockSrv(g_pScriptManager);
			SService<IQuestSrv> pQSrv(g_pScriptManager);
			if (pLockSrv->IsLocked(pFrobMsg->DstObjId))
				pQSrv->Set("tr_UseKeyLock", 1, 0);
			else
				pQSrv->Set("tr_UseKeyUnlock", 1, 0);
		}
		// This is the bug. GEN.OSM calls TryToUseKey before sending PlayerToolFrob.
		pKeySrv->TryToUseKey(m_iObjId, pFrobMsg->DstObjId, kKeyUseDefault);
		SService<IDamageSrv> pDSrv(g_pScriptManager);
		pDSrv->Slay(m_iObjId, pFrobMsg->Frobber);
	}
	else // !iSuccess
	{
		SService<ILockSrv> pLockSrv(g_pScriptManager);
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		if (( pPropSrv->Possessed(pFrobMsg->DstObjId, "RotDoor")
		   || pPropSrv->Possessed(pFrobMsg->DstObjId, "TransDoor"))
		  && !pPropSrv->Possessed(pFrobMsg->DstObjId, "Locked")
		  && !pLockSrv->IsLocked(pFrobMsg->DstObjId))
		{
			if (pFrobMsg->Frobber == oPlayer)
			{
				SimpleSend(m_iObjId, pFrobMsg->DstObjId, "PlayerToolFrob");
			}
			SService<IDoorSrv> pDoorSrv(g_pScriptManager);
			pDoorSrv->ToggleDoor(pFrobMsg->DstObjId);
			iSuccess = 1;
		}
		else
		{
			SimpleSend(m_iObjId, pFrobMsg->DstObjId, "Wrongkey", m_iObjId);
		}
	}
	if (pReply)
		MultiParmAssignInt(pReply, iSuccess);
	return 0;
}


/*******************
 * NewGasLight
 */

cScr_NewGasLight::~cScr_NewGasLight()
{
	if (m_pExtinguishable)
		m_pExtinguishable->Release();
}

void cScr_NewGasLight::InitScriptData()
{
	const sScrClassDesc* scr = g_pScriptManager->GetClass("Extinguishable");
	if (scr)
		m_pExtinguishable = (*scr->pfnFactory)(scr->pszClass, m_iObjId);

	m_iRealMode.Init(0);
	m_bStartsOn.Init(0);
	cScript::InitScriptData();
	RegisterMessageHandler("BeginScript", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnBeginScript));
	RegisterMessageHandler("Sim", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnSim));
	RegisterMessageHandler("Timer", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnTimer));
	RegisterMessageHandler("FrobWorldEnd", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnFrobWorldEnd));
	RegisterMessageHandler("TurnOn", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnTurnOn));
	RegisterMessageHandler("TurnOff", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnTurnOff));
	RegisterMessageHandler("Toggle", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnToggle));
	RegisterMessageHandler("FireStimStimulus", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnTurnOn));
	RegisterMessageHandler("WaterStimStimulus", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnExtinguish));
	RegisterMessageHandler("KOGasStimulus", static_cast<MessageHandlerFunc>(&cScr_NewGasLight::OnExtinguish));
}

long __stdcall cScr_NewGasLight::ReceiveMessage(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	long iRet = cScript::ReceiveMessage(pMsg, pReply, eTrace);
	if (m_pExtinguishable && iRet) {
		iRet = m_pExtinguishable->ReceiveMessage(pMsg, pReply, eTrace);
	}
	//RemoveSingleMetaProperty("FrobInert", m_iObjId);
	return iRet;
}

MSGHANDLER cScr_NewGasLight::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "ReallyOn"))
	{
		SService<ILightScrSrv> pLightSrv(g_pScriptManager);
		pLightSrv->SetMode(m_iObjId, m_iRealMode);
		return 0;
	}
	else if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "DelayInit"))
	{
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		pPropSrv->Set(m_iObjId, "SuspObj", "Is Suspicious", 0);
		if (m_pExtinguishable)
		{
			true_bool bOn;
			_DoScriptCall1a(IScr_AnimLight::IsLightOn,static_cast<IScr_AnimLight*>(m_pExtinguishable),&bOn);
			m_bStartsOn = static_cast<int>(bOn);
		}
		return 0;
	}
	return 1;
}

MSGHANDLER cScr_NewGasLight::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (pPropSrv->Possessed(m_iObjId, "AnimLight"))
	{
		cMultiParm mpMode;
		pPropSrv->Get(mpMode, m_iObjId, "AnimLight", "Mode");
		if (static_cast<int>(mpMode) == 2 || static_cast<int>(mpMode) == 8)
		{
			m_iRealMode = mpMode;
		}
	}
	return 0;
}

MSGHANDLER cScr_NewGasLight::OnSim(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (static_cast<sSimMsg*>(pMsg)->fStarting)
	{
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		if (!pPropSrv->Possessed(m_iObjId, "SuspObj"))
			pPropSrv->Add(m_iObjId, "SuspObj");
		g_pScriptManager->SetTimedMessage2(m_iObjId, "DelayInit", 100, kSTM_OneShot, 0);
	}
	return 1;
}

MSGHANDLER cScr_NewGasLight::OnFrobWorldEnd(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (ToggleEmitter(kTweqDoHalt))
		return 0;
	if (m_pExtinguishable)
		DoToggle();
	return 0;
}

MSGHANDLER cScr_NewGasLight::OnTurnOn(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	ToggleEmitter(kTweqDoHalt);
	if (m_pExtinguishable)
		DoTurnOn();
	return 0;
}

MSGHANDLER cScr_NewGasLight::OnTurnOff(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	ToggleEmitter(kTweqDoHalt);
	if (m_pExtinguishable)
		DoTurnOff();
	return 0;
}

MSGHANDLER cScr_NewGasLight::OnToggle(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	ToggleEmitter(kTweqDoHalt);
	if (m_pExtinguishable)
		DoToggle();
	return 0;
}

MSGHANDLER cScr_NewGasLight::OnExtinguish(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (!m_pExtinguishable)
		return 0;
	true_bool bOn;
	if (*_DoScriptCall1a(IScr_AnimLight::IsLightOn,static_cast<IScr_AnimLight*>(m_pExtinguishable),&bOn))
	{
		ToggleEmitter(kTweqDoActivate);
		DoTurnOff();
	}
	return 0;
}

int cScr_NewGasLight::ToggleEmitter(int iAction)
{
	if (ParamGetBool(m_iObjId, "no_emitter"))
		return 0;
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (!pPropSrv->Possessed(m_iObjId, "StTweqEmit"))
		return 0;
	int iRet = 0;
	cMultiParm mpState;
	pPropSrv->Get(mpState, m_iObjId, "StTweqEmit", "AnimS");
	iRet = static_cast<int>(mpState) & kTweqFlagOn;
	SService<IActReactSrv> pARSrv(g_pScriptManager);
	cMultiParm mpType = kTweqTypeEmitter;
	cMultiParm mpAction = iAction;
	pARSrv->React(pARSrv->GetReactionNamed("tweq_control"), 1.0, m_iObjId, 0,
			  mpType, mpAction, cMultiParm::Undef, cMultiParm::Undef, cMultiParm::Undef, cMultiParm::Undef, cMultiParm::Undef, cMultiParm::Undef);
	return iRet;
}

void cScr_NewGasLight::DoTurnOn(void)
{
	_DoScriptCall(IScr_AnimLight::TurnOn,static_cast<IScr_AnimLight*>(m_pExtinguishable));
	//if (! m_bStartsOn)
	{
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		pPropSrv->Set(m_iObjId, "SuspObj", "Is Suspicious", ! static_cast<int>(m_bStartsOn));
	}
	if (m_iRealMode != 0)
	{
		SService<ILightScrSrv> pLightSrv(g_pScriptManager);
		pLightSrv->SetMode(m_iObjId, 6);
		g_pScriptManager->SetTimedMessage2(m_iObjId, "ReallyOn", 100, kSTM_OneShot, 0);
	}
}

void cScr_NewGasLight::DoTurnOff(void)
{
	_DoScriptCall(IScr_AnimLight::TurnOff,static_cast<IScr_AnimLight*>(m_pExtinguishable));
	//if (! m_bStartsOn)
	{
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		pPropSrv->Set(m_iObjId, "SuspObj", "Is Suspicious", static_cast<int>(m_bStartsOn));
	}
}

void cScr_NewGasLight::DoToggle(void)
{
	// There's a bit of a race here if the light is toggled while the 
	// mode is the transitional "smoothly brighten"
	true_bool bOn;
	if (*_DoScriptCall1a(IScr_AnimLight::IsLightOn,static_cast<IScr_AnimLight*>(m_pExtinguishable),&bOn))
		DoTurnOff();
	else
		DoTurnOn();
}


/*******************
 * NewSuspicious
 */

bool cScr_NewSuspicious::TestIgnoreDoor(int iDoor)
{
	int iFrobber = GetOneLinkDest("~AIDoor", iDoor);
	if (iFrobber)
	{
	DebugPrintf("NewSuspicious: Door %d has frobber %d", iDoor, iFrobber);
		if (iFrobber == m_iObjId)
			return true;
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		cMultiParm mpMyTeam = 1, mpHisTeam = 1;
		if (pPropSrv->Possessed(m_iObjId, "AI_Team"))
			pPropSrv->Get(mpMyTeam, m_iObjId, "AI_Team", NULL);
		if (pPropSrv->Possessed(iFrobber, "AI_Team"))
			pPropSrv->Get(mpMyTeam, iFrobber, "AI_Team", NULL);
	DebugPrintf("NewSuspicious: My team is %d, his team is %d", 
			static_cast<int>(mpMyTeam), static_cast<int>(mpHisTeam));
		if (static_cast<int>(mpMyTeam) == static_cast<int>(mpHisTeam)
		 || 1 == static_cast<int>(mpMyTeam) || 1 == static_cast<int>(mpHisTeam))
		{
			return true;
		}
	}
	sLink slDouble;
	if (GetOneLinkByData("~ScriptParams", iDoor, 0, &slDouble, "Double", 7)
	 || GetOneLinkByData("ScriptParams", iDoor, 0, &slDouble, "Double", 7))
	{
		iFrobber = GetOneLinkDest("~AIDoor", slDouble.dest);
		if (iFrobber)
		{
		DebugPrintf("NewSuspicious: Double %d has frobber %d", slDouble.dest, iFrobber);
			if (iFrobber == m_iObjId)
				return true;
			SService<IPropertySrv> pPropSrv(g_pScriptManager);
			cMultiParm mpMyTeam = 1, mpHisTeam = 1;
			if (pPropSrv->Possessed(m_iObjId, "AI_Team"))
				pPropSrv->Get(mpMyTeam, m_iObjId, "AI_Team", NULL);
			if (pPropSrv->Possessed(iFrobber, "AI_Team"))
				pPropSrv->Get(mpMyTeam, iFrobber, "AI_Team", NULL);
		DebugPrintf("NewSuspicious: My team is %d, his team is %d", 
				static_cast<int>(mpMyTeam), static_cast<int>(mpHisTeam));
			if (static_cast<int>(mpMyTeam) == static_cast<int>(mpHisTeam)
			 || 1 == static_cast<int>(mpMyTeam) || 1 == static_cast<int>(mpHisTeam))
			{
				return true;
			}
		}
	}
	return false;
}

// returns the number of suspicious link. Links to objects with the same
// suspicious type are counted and returned in iLikeLinks.
int cScr_NewSuspicious::CountSuspiciousLinks(const char* pszType, int iSuspObj, int *iLikeLinks)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	
	int iCount = 0;
	int iLikeCount = 0;
	linkset lsLinks;
	pLS->GetAll(lsLinks, pLTS->LinkKindNamed("AISuspiciousLink"), m_iObjId, 0);
	for (; lsLinks.AnyLinksLeft(); lsLinks.NextLink())
	{
		cMultiParm mpSuspType;
		sLink sl = lsLinks.Get();
		if (sl.dest == iSuspObj)
			continue;
		if (pPropSrv->Possessed(sl.dest, "SuspObj"))
		{
			pPropSrv->Get(mpSuspType, sl.dest, "SuspObj", "Suspicious Type");
			if (!stricmp(pszType, static_cast<const char*>(mpSuspType)))
				++iLikeCount;
		}
		++iCount;
	}
#ifdef DEBUG
DebugPrintf("NewSuspicious: There are %d suspicious links. (%d of type %s)",
		iCount, iLikeCount, pszType);
#endif
	*iLikeLinks = iLikeCount;
	return iCount;
}

// calculates the level of suspiciousness for a particular object
// if time is non-zero, then other and similar links are not taken 
// into account (improves performance). 
float cScr_NewSuspicious::CalculateSuspicious(const char* pszType, int iSuspObj, int iTime)
{
	char szParam[strlen(pszType)+20];
	cScrStr strParam;
	SService<IDataSrv> pDS(g_pScriptManager);

	double factor = 0.0;

	if (iTime != 0 && m_iAwarenessFade != 0)
	{
		factor = (double)iTime / m_iAwarenessFade * -0.01;
	}

	sprintf(szParam, "%s_factor", pszType);
	pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
	if (strParam.IsEmpty())
	{
		strParam.Free();
		return 0.0;
	}
	factor += strtod(strParam, NULL);
	strParam.Free();

	if (iTime == 0)
	{
		double adj_others = 0.0, adj_like = 0.0;
		sprintf(szParam, "%s_factor_others", pszType);
		pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
		if (!strParam.IsEmpty())
			adj_others = strtod(strParam, NULL);
		strParam.Free();
		sprintf(szParam, "%s_factor_similar", pszType);
		pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
		if (!strParam.IsEmpty())
			adj_like = strtod(strParam, NULL);
		strParam.Free();

		if (adj_others != 0.0 || adj_like != 0.0)
		{
			int iOthers, iLike;
			iOthers = CountSuspiciousLinks(pszType, iSuspObj, &iLike);
			factor += adj_others * iOthers;
			factor += adj_like * iLike;
		}
	}

	sprintf(szParam, "%s_factor_random", pszType);
	pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
	if (!strParam.IsEmpty())
	{
		double adj_rand = strtod(strParam, NULL);
		factor += adj_rand * pDS->RandFlt0to1();
	}
	strParam.Free();

	if (factor < 0.0)
		return 0.0;

DebugPrintf("NewSuspicious: %d is suspicious by %0.2f at %d", iSuspObj, factor, iTime);
	return factor;
}

// sums the suspicious values of all links accounting for the age of the link
// if the value exceeds a threshold, then the alert level of the AI will be
// raised.
struct sCalcSuspData
{
	int iSuspObj;
	int iTime;
	double fFactor;
};
int cScr_NewSuspicious::CalcSuspIter(ILinkSrv* pLS, ILinkQuery* pLQ, IScript* pScript, void* pData)
{
	cScr_NewSuspicious* pSelf = static_cast<cScr_NewSuspicious*>(pScript);
	sCalcSuspData* pCalc = reinterpret_cast<sCalcSuspData*>(pData);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	cMultiParm mpLinkTime;
	pLTS->LinkGetData(mpLinkTime, pLQ->ID(), "Time Seen");
	int iSuspTime = pCalc->iTime - static_cast<int>(mpLinkTime);
	sLink sl;
	pLQ->Link(&sl);
	if (!pPropSrv->Possessed(sl.dest, "SuspObj"))
		return 1;
	cMultiParm mpSuspType;
	pPropSrv->Get(mpSuspType, sl.dest, "SuspObj", "Suspicious Type");
	pCalc->fFactor += pSelf->CalculateSuspicious(mpSuspType, sl.dest, iSuspTime);
	//if (sl.dest != pCalc->iSuspObj)
	//	continue;
	// If I were to trigger an action on the object, it'd be here
	return 1;
}

void cScr_NewSuspicious::ScanLinks(int iTime, int iSuspObj)
{
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	
	sCalcSuspData calc_info;
	calc_info.fFactor = 0.0;
	calc_info.iSuspObj = iSuspObj;
	calc_info.iTime = iTime;

	IterateLinks("AISuspiciousLink", m_iObjId, 0, CalcSuspIter, this, reinterpret_cast<void*>(&calc_info));

DebugPrintf("NewSuspicious: Total suspiciousness is %0.2f", calc_info.fFactor);
	for (int level=2; level>=0; --level)
	{
		if (m_fAlertThreshold[level] > 0.0 && calc_info.fFactor >= m_fAlertThreshold[level])
		{
			RaiseAlertLevel(level+1, m_iAlertRelaxTime[level]);
			break;
		}
	}
}

void cScr_NewSuspicious::HandleSuspicious(const char* pszType, int iSuspObj)
{
	char szParam[64];
	cScrStr strParam;
	SService<IDataSrv> pDS(g_pScriptManager);

#ifdef DEBUG
DebugPrintf("NewSuspicious: Running %s reactions for %d", pszType, iSuspObj);
#endif
	sprintf(szParam, "%s_alert", pszType);
	pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
	if (!strParam.IsEmpty())
	{
		int level = strtol(strParam, NULL, 10);
		if (level > 0)
		{
			int time = m_iAlertRelaxTime[level-1];
			strParam.Free();
			sprintf(szParam, "%s_alert_time", pszType);
			pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
			if (!strParam.IsEmpty())
				time = strtotime(strParam);
			RaiseAlertLevel(level, time);
		}
	}
	strParam.Free();

	sprintf(szParam, "%s_watch", pszType);
	pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
	if (!strParam.IsEmpty())
	{
		int time = 0;
		strParam.Free();
		sprintf(szParam, "%s_watch_time", pszType);
		pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
		if (!strParam.IsEmpty())
			time = strtotime(strParam);
		WatchObject(iSuspObj, time);
	}
	strParam.Free();

	sprintf(szParam, "%s_frob", pszType);
	pDS->GetString(strParam, "SuspParm.str", szParam, "", "strings");
	if (!strParam.IsEmpty())
	{
		if (! m_bActionPending)
		{
			if (!stricmp(pszType, "gaslight") && m_bGasRelightOnly)
			{
				SService<IPropertySrv> pPropSrv(g_pScriptManager);
				if (pPropSrv->Possessed(iSuspObj, "AnimLight"))
				{
					cMultiParm mpMode;
					pPropSrv->Get(mpMode, iSuspObj, "AnimLight", "Mode");
					switch (static_cast<int>(mpMode))
					{
					case 0: case 1: case 2: case 4: case 6: case 8: case 9:
						goto l_AbortFrobHandler;
						break;
					default:
						break;
					}
				}
			}
			GotoFrobObject(iSuspObj);
		}
	}
l_AbortFrobHandler:
	strParam.Free();
}

void cScr_NewSuspicious::ContinueAction(const char* pszAction, int iSuspObj)
{
	bool bIsSuspicious = false;
	char* szSuspType = NULL;
	SService<IPropertySrv> pPropSrv(g_pScriptManager);
	if (pPropSrv->Possessed(iSuspObj,"SuspObj"))
	{
		cMultiParm mpSusp;
		pPropSrv->Get(mpSusp, iSuspObj, "SuspObj", "Is Suspicious");
		bIsSuspicious = mpSusp;
		pPropSrv->Get(mpSusp, iSuspObj, "SuspObj", "Suspicious Type");
		szSuspType = new char[strlen(static_cast<const char*>(mpSusp))+1];
		if (szSuspType)
			strcpy(szSuspType, static_cast<const char*>(mpSusp));
	}

	if (bIsSuspicious)
	{
		if (!stricmp(pszAction, "frobobj"))
		{
			if (szSuspType && !stricmp(szSuspType, "lock"))
			{
				if (!pPropSrv->Possessed(iSuspObj, "Locked"))
					pPropSrv->Add(iSuspObj, "Locked");
				pPropSrv->SetSimple(iSuspObj, "Locked", cMultiParm(1));
				m_bActionPending = false;
			}
			else
			{
				SService<IAIScrSrv> pAISrv(g_pScriptManager);
				true_bool bSuccess;
				pAISrv->MakeFrobObj(bSuccess, m_iObjId, iSuspObj, kNormalPriorityAction, "endaction");
				if (!bSuccess)
					m_bActionPending = false;
			}
		}
		else if (!stricmp(pszAction, "endaction"))
		{
			m_bActionPending = false;
		}
	}
	else
	{
#ifdef DEBUG
	DebugPrintf("NewSuspicious: Aborting on no-longer-suspicious object.");
#endif
		m_bActionPending = false;
	}

	if (!m_bActionPending)
	{
		SService<ILinkSrv> pLS(g_pScriptManager);
		SService<ILinkToolsSrv> pLTS(g_pScriptManager);
		link lOwns;
		pLS->GetOne(lOwns, pLTS->LinkKindNamed("Owns"), m_iObjId, iSuspObj);
		if (lOwns != 0)
			pLS->Destroy(lOwns);
	}

	delete[] szSuspType;
}

void cScr_NewSuspicious::RaiseAlertLevel(int iLevel, int iTime)
{
#ifdef DEBUG
DebugPrintf("NewSuspicious: Raising alert to at least %d for %dms", iLevel, iTime);
#endif
	if (iLevel > m_iAlertLevel)
	{
		SService<IAIScrSrv> pAISrv(g_pScriptManager);
		pAISrv->SetMinimumAlert(m_iObjId, eAIScriptAlertLevel(iLevel));
		m_iAlertLevel = iLevel--;
	}
	else
		iLevel = m_iAlertLevel - 1;
	if (iTime != 0)
	{
		if (m_hAlertTimer)
			g_pScriptManager->KillTimedMessage(m_hAlertTimer);
		m_hAlertTimer = g_pScriptManager->SetTimedMessage2(m_iObjId, "RelaxAlert", 
				iTime, kSTM_OneShot, iLevel);
	}
}

void cScr_NewSuspicious::RelaxAlertLevel(int iLevel)
{
	int iTime = 0;
	while (iLevel > 0 && (iTime = m_iAlertRelaxTime[iLevel-1]) == 0)
		iLevel -= 1;
#ifdef DEBUG
DebugPrintf("NewSuspicious: Relaxing alert level to at least %d", iLevel);
#endif
	SService<IAIScrSrv> pAISrv(g_pScriptManager);
	pAISrv->SetMinimumAlert(m_iObjId, eAIScriptAlertLevel(iLevel));
	m_iAlertLevel = iLevel;
	if (iTime != 0)
	{
		if (m_hAlertTimer)
			g_pScriptManager->KillTimedMessage(m_hAlertTimer);
		m_hAlertTimer = g_pScriptManager->SetTimedMessage2(m_iObjId, "RelaxAlert", 
				iTime, kSTM_OneShot, iLevel-1);
	}
}

void cScr_NewSuspicious::GotoFrobObject(int iSuspObj)
{
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	true_bool _p;
	if (!*(pLS->AnyExist(_p, pLTS->LinkKindNamed("~Owns"), iSuspObj, 0)))
	{
		link lOwns;
		pLS->Create(lOwns, pLTS->LinkKindNamed("Owns"), m_iObjId, iSuspObj);

		SService<IAIScrSrv> pAISrv(g_pScriptManager);
		true_bool bSuccess;
		pAISrv->MakeGotoObjLoc(bSuccess, m_iObjId, iSuspObj, kNormalSpeed, kNormalPriorityAction, "frobobj");
		if (bSuccess)
		{
			m_bActionPending = true;
		}
	}
}

void cScr_NewSuspicious::WatchObject(int iSuspObj, int iRelaxTime)
{
	SService<ILinkSrv> pLS(g_pScriptManager);
	SService<ILinkToolsSrv> pLTS(g_pScriptManager);
	true_bool _p;
	if (!*(pLS->AnyExist(_p, pLTS->LinkKindNamed("AIWatchObj"), m_iObjId, iSuspObj)))
	{
		link lWatch;
		pLS->Create(lWatch, pLTS->LinkKindNamed("AIWatchObj"), m_iObjId, iSuspObj);
		if (iRelaxTime != 0)
		{
			g_pScriptManager->SetTimedMessage2(m_iObjId, "RelaxWatch", iRelaxTime, kSTM_OneShot, iSuspObj);
		}
	}
}

void cScr_NewSuspicious::InitParams(void)
{
	SService<IDataSrv> pDS(g_pScriptManager);
	cScrStr strParam;

	pDS->GetString(strParam, "SuspParm.str", "fade_time", "", "strings");
	if (!strParam.IsEmpty())
		m_iAwarenessFade = strtotime(strParam);
	else
		m_iAwarenessFade = 0;
	strParam.Free();

	pDS->GetString(strParam, "SuspParm.str", "alert_level_1", "", "strings");
	if (!strParam.IsEmpty())
		m_fAlertThreshold[0] = strtod(strParam, NULL);
	else
		m_fAlertThreshold[0] = 0.0;
	strParam.Free();
	pDS->GetString(strParam, "SuspParm.str", "alert_time_1", "", "strings");
	if (!strParam.IsEmpty())
		m_iAlertRelaxTime[0] = strtotime(strParam);
	else
		m_iAlertRelaxTime[0] = 10000;
	strParam.Free();

	pDS->GetString(strParam, "SuspParm.str", "alert_level_2", "", "strings");
	if (!strParam.IsEmpty())
		m_fAlertThreshold[1] = strtod(strParam, NULL);
	else
		m_fAlertThreshold[1] = 0.0;
	strParam.Free();
	pDS->GetString(strParam, "SuspParm.str", "alert_time_2", "", "strings");
	if (!strParam.IsEmpty())
		m_iAlertRelaxTime[1] = strtotime(strParam);
	else
		m_iAlertRelaxTime[1] = 10000;
	strParam.Free();

	pDS->GetString(strParam, "SuspParm.str", "alert_level_3", "", "strings");
	if (!strParam.IsEmpty())
		m_fAlertThreshold[2] = strtod(strParam, NULL);
	else
		m_fAlertThreshold[2] = 0.0;
	strParam.Free();
	pDS->GetString(strParam, "SuspParm.str", "alert_time_3", "", "strings");
	if (!strParam.IsEmpty())
		m_iAlertRelaxTime[2] = strtotime(strParam);
	else
		m_iAlertRelaxTime[2] = 10000;
	strParam.Free();

	pDS->GetString(strParam, "SuspParm.str", "gaslight_frob", "", "strings");
	if (!strParam.IsEmpty())
		m_bGasRelightOnly = (stricmp("on", strParam) == 0);
	else
		m_bGasRelightOnly = false;
	strParam.Free();

	m_bParamsInitted = true;
}

MSGHANDLER cScr_NewSuspicious::OnBeginScript(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	InitParams();

	m_hAlertTimer.Init();
	m_iAlertLevel.Init(0);
	m_bActionPending.Init(0);
	return 1;
}

MSGHANDLER cScr_NewSuspicious::OnTimer(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (! m_bParamsInitted)
		InitParams();

	if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "RelaxAlert"))
	{
		m_hAlertTimer = NULL;
		SService<IPropertySrv> pPropSrv(g_pScriptManager);
		cMultiParm mpAIMode;
		pPropSrv->Get(mpAIMode, m_iObjId, "AI_Mode", NULL);
		if (5 != static_cast<int>(mpAIMode))
		{
			int level = static_cast<int>(pMsg->data);
			if (level >= 0)
				RelaxAlertLevel(level);
		}
		return 0;
	}
	else if (!stricmp(static_cast<sScrTimerMsg*>(pMsg)->name, "RelaxWatch"))
	{
		int iSuspObj = static_cast<int>(pMsg->data);
		SService<ILinkSrv> pLS(g_pScriptManager);
		SService<ILinkToolsSrv> pLTS(g_pScriptManager);
		true_bool _p;
		if (*(pLS->AnyExist(_p, pLTS->LinkKindNamed("AIWatchObj"), m_iObjId, iSuspObj)))
		{
			link lWatch;
			pLS->GetOne(lWatch, pLTS->LinkKindNamed("AIWatchObj"), m_iObjId, iSuspObj);
			pLS->Destroy(lWatch);
		}
		return 0;
	}
	return 1;
}

MSGHANDLER cScr_NewSuspicious::OnObjActResult(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (! m_bParamsInitted)
		InitParams();

	sAIObjActResultMsg* pActMsg = static_cast<sAIObjActResultMsg*>(pMsg);
	if (pActMsg->result == kActionDone)
	{
		ContinueAction(static_cast<const char*>(pActMsg->result_data), pActMsg->target);
		if (! m_bActionPending)
		{
			ScanLinks(pMsg->time, pActMsg->target);
		}
	}
	return 0;
}

MSGHANDLER cScr_NewSuspicious::OnSuspicious(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (! m_bParamsInitted)
		InitParams();

	int iSuspObj = StrToObject(static_cast<const char*>(pMsg->data));
	const char* pszType = static_cast<const char*>(pMsg->data2);

	if (!stricmp(pszType, "generic"))
	{
		SService<IObjectSrv> pOS(g_pScriptManager);
		object oArc;
		true_bool _p;
		pOS->Named(oArc, "Windows");
		if (*(pOS->InheritsFrom(_p, iSuspObj, oArc)))
		{
			pszType = "glass";
			goto l_HandleSuspicious;
		}
		pOS->Named(oArc, "ExBanner");
		if (*(pOS->InheritsFrom(_p, iSuspObj, oArc)))
		{
			pszType = "banner";
			goto l_HandleSuspicious;
		}
		pOS->Named(oArc, "RopeArrowRope");
		if (*(pOS->InheritsFrom(_p, iSuspObj, oArc)))
		{
			pszType = "rope";
			goto l_HandleSuspicious;
		}
	}

	if (!stricmp(pszType, "door") || !stricmp(pszType, "lock"))
	{
		if (TestIgnoreDoor(iSuspObj))
		{
			MultiParmAssignInt(pReply, 0);
			return 0;
		}
	}

l_HandleSuspicious:
#ifdef DEBUG
DebugPrintf("NewSuspicious: Got suspicious message, type %s", pszType);
#endif
	if (CalculateSuspicious(pszType, iSuspObj, 0) >= 1.0)
	{
		HandleSuspicious(pszType, iSuspObj);
	}
	if (!m_bActionPending)
	{
		ScanLinks(pMsg->time, iSuspObj);
	}

	MultiParmAssignInt(pReply, 1);
	return 0;
}


/******************
 * NewSecurityDoor
 */
cScr_NewSecurityDoor::~cScr_NewSecurityDoor()
{
	if (m_pSecurityDoor)
		m_pSecurityDoor->Release();
}

void cScr_NewSecurityDoor::InitScriptData()
{
	const sScrClassDesc* scr = g_pScriptManager->GetClass("SecurityDoor");
	if (scr)
		m_pSecurityDoor = (*scr->pfnFactory)(scr->pszClass, m_iObjId);

	cScript::InitScriptData();
	RegisterMessageHandler("DoorOpen", static_cast<MessageHandlerFunc>(&cScr_NewSecurityDoor::OnDoorOpenClose));
	RegisterMessageHandler("DoorClose", static_cast<MessageHandlerFunc>(&cScr_NewSecurityDoor::OnDoorOpenClose));
}

long __stdcall cScr_NewSecurityDoor::ReceiveMessage(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	long iRet = cScript::ReceiveMessage(pMsg, pReply, eTrace);
	if (m_pSecurityDoor && iRet) {
		iRet = m_pSecurityDoor->ReceiveMessage(pMsg, pReply, eTrace);
	}
	return iRet;
}

MSGHANDLER cScr_NewSecurityDoor::OnDoorOpenClose(sScrMsg* pMsg, sMultiParm* pReply, eScrTraceAction eTrace)
{
	if (GetOneLinkDest("~AIDoor", m_iObjId) != 0)
	{
		return 0;
	}
	sLink slDouble;
	if (GetOneLinkByData("~ScriptParams", m_iObjId, 0, &slDouble, "Double", 7)
	 || GetOneLinkByData("ScriptParams", m_iObjId, 0, &slDouble, "Double", 7))
	{
		if (GetOneLinkDest("~AIDoor", slDouble.dest) != 0)
			return 0;
	}
	return 1;
}


#endif // _DARKGAME == 2
