#include "ScriptLib.h"

#include <cstring>
#include <cctype>
#include <cstdlib>

extern const char* g_pszParamDelim;
extern const char* g_pszQuotes;

int GetParamObject(const char* pszString, const char* pszParam)
{
	if (!pszString || !pszParam)
		return 0;
	char* pszRet = NULL;
	char szTemp[strlen(pszString) + 1];
	strcpy(szTemp, pszString);
	char* pszSep, *pszToken;
	for (pszSep = szTemp, pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes); 
	     pszToken; pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes))
	{
		while (isspace(*pszToken)) ++pszToken;
		char* pszStart = strchr(pszToken, '=');
		if (pszStart)
			*pszStart++ = '\0';
		if (!stricmp(pszToken, pszParam))
		{
			if (!pszStart)
				break;
			while (isspace(*pszStart)) ++pszStart;
			if (*pszStart == '"' || *pszStart == '\'')
			{
				char quote = *pszStart++;
				char* pszEnd = strrchr(pszStart, quote);
				if (!pszEnd)
					pszEnd = pszStart + strlen(pszStart);
				char* pszChar = pszRet = pszStart;
				while (pszStart < pszEnd)
				{
					if (*pszStart == '\\' && 
					    (pszStart[1] == '\\' || pszStart[1] == quote))
					{
						++pszStart;
					}
					*pszChar++ = *pszStart++;
				}
				*pszChar = '\0';
			}
			else
			{
				int iLen = strlen(pszStart);
				pszRet = pszStart;
				pszRet[iLen] = '\0';
			}
			break;
		}
	}
	int iRet = StrToObject(pszRet);
	return iRet;
}

