#include "ScriptLib.h"

#include <cstring>
#include <cctype>

using namespace std;

extern const char* g_pszParamDelim;
extern const char* g_pszQuotes;

char* GetParamString(const char* pszString, const char* pszParam)
{
	if (!pszString || !pszParam)
		return NULL;
	char* pszRet = NULL;
	char szTemp[strlen(pszString) + 1];
	strcpy(szTemp, pszString);
	char* pszSep, *pszToken;
	for (pszSep = szTemp, pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes); 
	     pszToken; pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes))
	{
		while (isspace(*pszToken)) ++pszToken;
		char* pszStart = strchr(pszToken, '=');
		if (pszStart)
			*pszStart++ = '\0';
		if (!stricmp(pszToken, pszParam))
		{
			if (!pszStart)
				break;
			while (isspace(*pszStart)) ++pszStart;
			char* pszEnd, quote;
			if (*pszStart == '"' || *pszStart == '\'')
			{
				quote = *pszStart++;
				pszEnd = strrchr(pszStart, quote);
				if (!pszEnd)
					pszEnd = pszStart + strlen(pszStart);
			}
			else
			{
				quote = 0;
				pszEnd = pszStart + strlen(pszStart);
			}
			int iLen = pszEnd - pszStart;
			pszRet = reinterpret_cast<char*>(g_pMalloc->Alloc(iLen + 1));
			if (pszRet)
			{
				if (quote)
				{
					char* pszChar = pszRet;
					while (pszStart < pszEnd)
					{
						if (*pszStart == '\\' && 
						    (pszStart[1] == '\\' || pszStart[1] == quote))
						{
							++pszStart;
						}
						*pszChar++ = *pszStart++;
					}
					*pszChar = '\0';
				}
				else
				{
					strncpy(pszRet, pszStart, iLen);
					pszRet[iLen] = '\0';
				}
			}
			break;
		}
	}
	return pszRet;
}

