#include "ScriptLib.h"

#include <cstring>
#include <cctype>
#include <cstdio>

using namespace std;

#ifndef __BORLANDC__
extern "C" char* _stpcpy(char* dst, const char* src);
#endif

extern const char* g_pszParamDelim;
extern const char* g_pszQuotes;

char* SetParamString(char* pszString, const char* pszParam, const char* pszVal)
{
	if (!pszParam || !pszVal)
		return NULL;
	int iLen = pszString ? strlen(pszString) : 0;
	iLen += strlen(pszParam) + 2;
	char quote = 0;
	const char* pszChar = pszVal;
	while (*pszChar)
	{
		switch (*pszChar++)
		{
		case '"':
			if (!quote) quote = '\'';
			iLen += 2;
			break;
		case '\'':
			quote = '"';
			iLen += 2;
			break;
		case '\\':
			++iLen;
		case ';': case '=': case '!': case ' ':
			if (!quote) quote = '"';
		default:
			++iLen;
			break;
		}
	}
	if (quote)
		iLen += 2;
	char* pszNew = reinterpret_cast<char*>(g_pMalloc->Alloc(iLen + 1));
	if (!pszNew)
		return NULL;
	char* pszRet;
	if (quote)
	{
		pszRet = pszNew + sprintf(pszNew, "%s=", pszParam);
		pszChar = pszVal;
		*pszRet++ = quote;
		while (*pszChar)
		{
			if (*pszChar == quote || *pszChar == '\\')
				*pszRet++ = '\\';
			*pszRet++ = *pszChar++;
		}
		*pszRet++ = quote;
	}
	else
		pszRet = pszNew + sprintf(pszNew, "%s=%s", pszParam, pszVal);
	if (pszString)
	{
		char* pszSep, *pszToken;
		for (pszSep = pszString, pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes); 
		     pszToken; pszToken = strqsep(&pszSep, g_pszParamDelim, g_pszQuotes))
		{
			while (isspace(*pszToken)) ++pszToken;
			if (!*pszToken)
				continue;
			char* pszStart = strchr(pszToken, '=');
			if (pszStart)
				*pszStart++ = '\0';
			if (stricmp(pszToken, pszParam))
			{
				*pszRet++ = *g_pszParamDelim;
				pszRet = _stpcpy(pszRet, pszToken);
				if (pszStart)
				{
					*pszRet++ = '=';
					pszRet = _stpcpy(pszRet, pszStart);
				}
			}
		}
	}
	*pszRet = '\0';
	return pszNew;
}

