/**********************************************
 * Common routines for loot/in-game store scripts
 */
#ifndef VENDORLIB_H
#define VENDORLIB_H

#if _MSC_VER > 1000
#pragma once
#endif

// Returns the dest of a 'Store' ScriptParams link
// or the same object if there is no link.
int VendorGetStore(int iObj);

// Returns the dest of a 'Cart' ScriptParams link 
int VendorGetCart(int iObj);

// Returns the dest of a 'Item' ScriptParams link
int VendorGetItem(int iObj);

// Return value is total loot. Any param can be NULL to ignore.
// iObj can be 0 to use the Player object.
int VendorGetLoot(int iObj, int* iGold, int* iGems, int* iGoods);

// Adds to the loot of an object. (Can be negative)
// iObj can be 0 to use the Player object.
void VendorAddLoot(int iObj, int iGold, int iGems=0, int iGoods=0);

enum eVendorDebitType
{
	kDebitEvenly = 0,
	kDebitGold,
	kDebitGems,
	kDebitGoods,
	kDebitGoldFirst,
	kDebitExact,
};

// iObj can be 0 to use the Player object.
// Returns non-zero if successful.
int VendorDebitLoot(int iObj, int iAmount, eVendorDebitType eType);
int VendorDebitLoot(int iObj, int iGold, int iGems, int iGoods);

#endif // VENDORLIB_H
